void mysql_clear_show_message(gtkwidget *widget,gpointer data){
    gtk_grab_remove(widget);
}    

void mysql_close_show_message(gtkwidget *widget,gpointer data){
    gtk_widget_destroy(gtk_widget(data));
}    

void mysql_show_message(char *title,char *message){
    gtkwidget *label;
    gtkwidget *button;
    gtkwidget *dialog_window;
    
    dialog_window=gtk_dialog_new();
    gtk_signal_connect(gtk_object(dialog_window),"destroy",gtk_signal_func(mysql_clear_show_message),null);
    gtk_window_set_title(gtk_window(dialog_window),title);
    gtk_container_border_width(gtk_container(dialog_window),0);
    
    button=gtk_button_new_with_label("ok");
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(mysql_close_show_message),(gpointer)dialog_window);
    gtk_widget_set_flags(button,gtk_can_default);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog_window)->action_area),button,false,false,0);
    gtk_widget_grab_default(button);
    gtk_widget_show(button);
    
    label=gtk_label_new(message);
    gtk_widget_show(label);
    gtk_misc_set_padding(gtk_misc(label),10,10);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog_window)->vbox),label,true,true,0);
    
    gtk_widget_show(dialog_window);
    gtk_grab_add(dialog_window);
}    

gtkwidget *mysql_make_sub_menu(gtkwidget *menu,char *name){
    gtkwidget *menuitem;
    gtkwidget *submenu;
    
    menuitem=gtk_menu_item_new_with_label(name);
    gtk_widget_show(menuitem);
    gtk_menu_bar_append(gtk_menu_bar(menu),menuitem);
    
    submenu=gtk_menu_new();
    gtk_widget_show(submenu);
    gtk_menu_item_set_submenu(gtk_menu_item(menuitem),submenu);
    
    return submenu;
}    

gtkwidget *mysql_make_menu_item(gtkwidget *menu,char *name,char *accel,char *tip,gtksignalfunc func,gpointer data){
    gtkwidget *menuitem;
    
    if(name&&strlen(name)){
	menuitem=gtk_menu_item_new_with_label(name);
	gtk_widget_show(menuitem);
	gtk_signal_connect(gtk_object(menuitem),"activate",gtk_signal_func(func),data);
    }
    else{
	menuitem=gtk_menu_item_new();
	gtk_widget_show(menuitem);
    }
    gtk_menu_append(gtk_menu(menu),menuitem);
    
    if(accel_group==null){
	accel_group=gtk_accel_group_new();
	gtk_accel_group_attach(accel_group,gtk_object(window));
    }
    if(accel&&accel[0]=='^'){
	gtk_widget_add_accelerator(menuitem,"activate",accel_group,accel[1],gdk_control_mask,gtk_accel_visible);	
    }
    if(tip&&strlen(tip)){
	gtk_tooltips_set_tip(tooltips,menuitem,tip,null);
    }
    return menuitem;
}    		
    
typedef struct{
    void (*func)(gchar *);
    gtkwidget *filesel;
}typfileselectiondata;
    
char *filename=null;

void mysql_destroy(gtkwidget *widget,gpointer data){
    gtk_grab_remove(widget);
    g_free(data);
}

void mysql_file_ok(gtkwidget *widget,gpointer data){
    char *tempfile;
    typfileselectiondata *localdata;
    gtkwidget *filew;
    localdata=(typfileselectiondata *)data;
    filew=localdata->filesel;
    tempfile=gtk_file_selection_get_filename(gtk_file_selection(filew));
    if(filename){
	g_free(filename);
    }
    filename=g_strdup(tempfile);
    (*(localdata->func))(filename);
    gtk_widget_destroy(filew);
}    	
    
void mysql_get_file_name(char *title,void (*callback)(char *)){
    gtkwidget *filew=null;
    typfileselectiondata *data;
    filew=gtk_file_selection_new(title);
    data=g_malloc(sizeof(typfileselectiondata));
    data->func=callback;
    data->filesel=filew;
    gtk_signal_connect(gtk_object(filew),"destroy",gtk_signal_func(mysql_destroy),(gpointer)data);
    gtk_signal_connect(gtk_object(gtk_file_selection(filew)->ok_button),"clicked",gtk_signal_func(mysql_file_ok),(gpointer)data);
    gtk_signal_connect_object(gtk_object(gtk_file_selection(filew)->cancel_button),"clicked",gtk_signal_func(gtk_widget_destroy),(gpointer)filew);
    if(filename){
	gtk_file_selection_set_filename(gtk_file_selection(filew),filename);
    }
    gtk_widget_show(filew);
    gtk_grab_add(filew);
}    	
    
void menu_save(gtkwidget *widget,gpointer data);    

void mysql_load_file(char *filename){
    char buffer[512];
    int nchars;
    file *infile;
    struct stat filestatus;
    long filelen=0;
    
    gtk_text_freeze(gtk_text(text));
    gtk_editable_delete_text(gtk_editable(text),0,-1);
    
    stat(filename,&filestatus);
    filelen=filestatus.st_size;
    
    infile=fopen(filename,"r");
    
    if(infile){
	while((nchars=fread(buffer,1,512,infile))>0){
	    gtk_text_insert(gtk_text(text),null,null,null,buffer,nchars);
	    if(nchars<512){
		break;
	    }
	}
    }	
    fclose(infile);
    gtk_text_thaw(gtk_text(text));
}        	        
	    	
void mysql_save_file(char *filename){
    menu_save(null,null);
}
    		
void menu_new(gtkwidget *widget,gpointer data){
    gtk_editable_delete_text(gtk_editable(text),0,-1);
    g_free(filename);
    filename=null;
}
void menu_open(gtkwidget *widget,gpointer data){
    mysql_get_file_name("open",mysql_load_file);
}

int lookforstring(char *haystack,char *needle,int nstart){
    int nhaystacklength=strlen(haystack);
    int nneedlelength=strlen(needle);
    int npos;
    for(npos=nstart;npos<nhaystacklength;npos++){
	if(strncmp(&haystack[npos],needle,nneedlelength)==0){
	    return npos;
	}
    }
    return -1;
}    	    
    

void findfunction(gtkwidget *widget,gpointer data){
    int nindex;
    char *haystack;
    haystack=gtk_editable_get_chars(gtk_editable(text),(gint)0,(gint)gtk_text_get_length(gtk_text(text)));
    if(needle){
	g_free(needle);
    }
    needle=gtk_editable_get_chars(gtk_editable(entry),0,-1);
    nindex=gtk_editable(text)->selection_end_pos;
    nindex=lookforstring(haystack,needle,nindex);
    if(nindex>0){
	gtk_text_set_point(gtk_text(text),nindex);
	gtk_text_insert(gtk_text(text),null,null,null," ",1);
	gtk_text_backward_delete(gtk_text(text),1);
	gtk_editable_select_region(gtk_editable(text),nindex,nindex+strlen(needle));
	dialog_window=null;
    }
    else{
	mysql_show_message("find...","not found.");
    }
    g_free(haystack);	 		    
}

void cancelfunction(gtkwidget *widget,gpointer data){
     gtk_widget_destroy(gtk_widget(data));
     dialog_window=null;
}

void closefinddialog(gtkwidget *widget,gpointer data){
     gtk_widget_destroy(gtk_widget(data));
     dialog_window=null;
}

     



void findstringdialog(char *message,void (*yesfunc)(gtkwidget *,gpointer),void (*nofunc)(gtkwidget *,gpointer)){
    gtkwidget *label;
    gtkwidget *button;
    gtkwidget *hbox;
    if(dialog_window){
	return;
    }
    dialog_window=gtk_dialog_new();
    gtk_signal_connect(gtk_object(dialog_window),"destroy",gtk_signal_func(closefinddialog),dialog_window);
    gtk_window_set_title(gtk_window(dialog_window),"find");
    gtk_container_set_border_width(gtk_container(dialog_window),5);
    hbox=gtk_hbox_new(false,1);
    gtk_widget_show(hbox);
    label=gtk_label_new("find what:");
    gtk_widget_show(label);
    entry=gtk_entry_new();
    gtk_widget_show(entry);
    if(needle){
	gtk_entry_set_text(gtk_entry(entry),needle);
    }
    gtk_box_pack_start(gtk_box(hbox),label,false,false,0);
    gtk_box_pack_start(gtk_box(hbox),entry,false,false,0);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog_window)->vbox),hbox,false,false,0);
    button=gtk_button_new_with_label("find next");
    gtk_widget_show(button);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(yesfunc),dialog_window);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog_window)->action_area),button,false,false,0);
    button=gtk_button_new_with_label("cancel");
    gtk_widget_show(button);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(nofunc),dialog_window);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog_window)->action_area),button,false,false,0);
    gtk_widget_set_flags(button,gtk_can_default);
    gtk_widget_grab_default(button);
    gtk_widget_show(dialog_window);
}    
    
void menu_save(gtkwidget *widget,gpointer data){
    file *outfile;
    char *buffer;
    int nchars;
    if(filename==null){
	mysql_show_message("mysql alert","file does not exist");
	return;
    }	
    gtk_text_freeze(gtk_text(text));
    outfile=fopen(filename,"w");
    if(outfile){
	buffer=gtk_editable_get_chars(gtk_editable(text),(gint)0,(gint)gtk_text_get_length(gtk_text(text)));
	nchars=fwrite(buffer,sizeof(char),strlen(buffer),outfile);
	fclose(outfile);
	if(nchars!=strlen(buffer)){
	    mysql_show_message("save","error: can't write file.");
	}
	g_free(buffer);
    }
    else{
	mysql_show_message("save","error: can't save file.");
    }
    gtk_text_thaw(gtk_text(text));
}    		        
    
void menu_saveas(gtkwidget *widget,gpointer data){
    mysql_get_file_name("save as",mysql_save_file);
}
void menu_quit(gtkwidget *widget,gpointer data){
}
void menu_cut(gtkwidget *widget,gpointer data){
    gtk_editable_cut_clipboard(gtk_editable(text));
}
void menu_find(gtkwidget *widget,gpointer data){
    findstringdialog("find",findfunction,cancelfunction);
}
void menu_copy(gtkwidget *widget,gpointer data){
    gtk_editable_copy_clipboard(gtk_editable(text));
}
void menu_paste(gtkwidget *widget,gpointer data){
    gtk_editable_paste_clipboard(gtk_editable(text));
}

void mysql_make_menu(gtkwidget *vbox){
    gtkwidget *menubar;
    gtkwidget *menu;
    gtkwidget *menuitem;
    
    accel_group=gtk_accel_group_new();
    gtk_accel_group_attach(accel_group,gtk_object(vbox));
    
    menubar=gtk_menu_bar_new();
    gtk_widget_show(menubar);
    gtk_box_pack_start(gtk_box(vbox),menubar,false,true,0);
    
    menu=mysql_make_sub_menu(menubar,hangul?"":"file");
    mysql_make_menu_item(menu,hangul?"":"new","","",menu_new,"new");
    mysql_make_menu_item(menu,hangul?"":"open","","",menu_open,"open");
    mysql_make_menu_item(menu,hangul?"":"save","","",menu_save,"save");
    mysql_make_menu_item(menu,hangul?"ٸ ̸ ":"save as","","",menu_saveas,"save as");
    
    menu=mysql_make_sub_menu(menubar,hangul?"":"edit");
    mysql_make_menu_item(menu,hangul?"ڸ":"cut","","",menu_cut,"cut");	    
    mysql_make_menu_item(menu,hangul?"ϱ":"copy","","",menu_copy,"copy");	    
    mysql_make_menu_item(menu,hangul?"̱":"paste","","",menu_paste,"paste");	    
    
    menu=mysql_make_sub_menu(menubar,hangul?"ã":"find");
    mysql_make_menu_item(menu,hangul?"ã":"find item","","",menu_find,"find");	    
}    

void mysql_create_text(gtkwidget *vbox){
    gtkwidget *table;
    gtkwidget *s_window;
    
    s_window=gtk_scrolled_window_new(null,null);
    gtk_scrolled_window_set_policy(gtk_scrolled_window(s_window),gtk_policy_automatic,gtk_policy_automatic);
    gtk_widget_show(s_window);
    
    gtk_box_pack_start(gtk_box(vbox),s_window,true,true,0);

    text=gtk_text_new(gtk_scrolled_window_get_hadjustment(gtk_scrolled_window(s_window)),gtk_scrolled_window_get_vadjustment(gtk_scrolled_window(s_window)));
    gtk_widget_show(text);
    gtk_text_set_editable(gtk_text(text),true);
    
    gtk_container_add(gtk_container(s_window),text);
}    
        
void mysql_make_edit_page(gtkwidget *frame){
    gtkwidget *vbox;
    
    vbox=gtk_vbox_new(false,0);
    gtk_widget_show(vbox);
    gtk_container_add(gtk_container(frame),vbox);
    
    mysql_make_menu(vbox);
    mysql_create_text(vbox);
}
