#include "g.h"
#include <gnome.h>
#include "x.h"
#include <mysql.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include "j.h"
#include "edit.h"
#include "user.h"
#include "tree.h"
#include "bar.h"
#include "run.h"
#include "log.h"

void tree_page(gtknotebook *note,gtknotebookpage *page,gint page_num,gpointer data){
    char *v;
    gtk_statusbar_pop(gtk_statusbar(bar1),id1);
    gtk_label_get(gtk_label(page->tab_label),&v);
    gtk_statusbar_push(gtk_statusbar(bar1),id1,v);
}

void mysql_view_table(){
    int j;
    int k;
    int x=0;
    int num;
    int rows;
    char *c[num];
    char *t[20];

    gtkwidget *dialog;
    gtkwidget *button;
    
    dialog=gtk_dialog_new();
    gtk_container_set_border_width(gtk_container(gtk_dialog(dialog)->vbox),5);
    gtk_widget_set_usize(gtk_widget(dialog),500,200);    
    gtk_window_set_title(gtk_window(dialog),hangul?"̿ť ׺":"MySQL Navigator");

    scrolled_window=gtk_scrolled_window_new(null,null);
    gtk_scrolled_window_set_policy(gtk_scrolled_window(scrolled_window),gtk_policy_automatic,gtk_policy_always);
    
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog)->vbox),scrolled_window,true,true,0);
    gtk_widget_show(scrolled_window);
    
    num=mysql_num_fields(res);
    rows=mysql_num_rows(res);
    while(field=mysql_fetch_field(res)){
	t[x++]=field->name;
    }   
    clist=gtk_clist_new_with_titles(num,t);
    gtk_container_add(gtk_container(scrolled_window),clist);

    for(j=0;j<rows;j++){
	row=mysql_fetch_row(res);
	for(k=0;k<num;k++){
	    c[k]=row[k];
	}
	gtk_clist_append(gtk_clist(clist),c);
    }
    for(j=0;j<num;j++){
	gtk_clist_set_column_auto_resize(gtk_clist(clist),j,true);
    }	
    gtk_widget_show(clist);	      
    
    button=gtk_button_new_with_label("x");
    gtk_widget_set_flags(button,gtk_can_default);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog)->action_area),button,false,true,0);			
    gtk_widget_grab_default(button);
    gtk_widget_show(button);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(mysql_close_dialog),(gpointer)dialog);
    gtk_widget_show(dialog);
}


void gtk_quit(gtkwidget *widget,gpointer data){
    if(timer1!=null){
	gtk_timeout_remove(timer1);
    }
    if(timer2!=null){
	gtk_timeout_remove(timer2);
    }
    if(timer3!=null){
	gtk_timeout_remove(timer3);
    }
    gtk_main_quit();
}    

void mysql_link(){
    mysql_init(&my_sql);
    if(!mysql_real_connect(&my_sql,host,user,password,null,3306,null,0)){
	g_print("%s\n",mysql_error(&my_sql));
	exit(1);
    }
}    	

void my_make_tree_note(gtkwidget *hpaned){
    gtkwidget *note;
    gtkwidget *vbox;
    gtkwidget *label;
    gtkwidget *frame;
    
    note=gtk_notebook_new();
    gtk_signal_connect(gtk_object(note),"switch-page",gtk_signal_func(tree_page),null);
    gtk_paned_add1(gtk_paned(hpaned),note);
    gtk_widget_show(note);
    gtk_notebook_set_tab_pos(gtk_notebook(note),gtk_pos_bottom);
    
    label=gtk_label_new(hangul?"Ʈ":"tree");
    gtk_widget_show(label);
    vbox=gtk_vbox_new(false,0);
    gtk_widget_show(vbox);
    gtk_container_set_border_width(gtk_container(vbox),1);
    gtk_notebook_append_page(gtk_notebook(note),vbox,label);
    make_tree_page(vbox);
    
    label=gtk_label_new(hangul?"":"info");
    gtk_widget_show(label);
    frame=gtk_frame_new(null);
    gtk_widget_show(frame);
    gtk_container_set_border_width(gtk_container(vbox),1);
    gtk_notebook_append_page(gtk_notebook(note),frame,label);
    tree_info_page(frame);
    
}        

void mysql_close_dialog(gtkwidget *widget,gpointer data){
    gtk_widget_destroy(gtk_widget(data));
}    

void mysql_alert(gchar *message){
    gtkwidget *dialog;
    
    dialog=gnome_message_box_new(message,gnome_message_box_warning,gnome_stock_button_ok,null);
    gtk_window_set_title(gtk_window(dialog),hangul?"̿ť ׺":"MySQL Navigator");
    gtk_widget_show(dialog);    


    /*gtkwidget *dialog;
    gtkwidget *label;
    gtkwidget *button;
    dialog=gtk_dialog_new();
    gtk_window_set_title(gtk_window(dialog),"MySQL Alert!");
    label=gtk_label_new(message);
    gtk_misc_set_padding(gtk_misc(label),10,10);
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog)->vbox),label,true,true,0);
    gtk_widget_show(label);
    button=gtk_button_new_with_label("x");
    gtk_box_pack_start(gtk_box(gtk_dialog(dialog)->action_area),button,false,true,0);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(mysql_close_dialog),(gpointer)dialog);
    gtk_widget_show(button);
    gtk_widget_set_flags(button,gtk_can_default);
    gtk_widget_grab_default(button);
    gtk_widget_show(dialog);    
    */
}


void mysql_quit(gtkwidget *widget,gpointer data){
    mysql_close(&my_sql);
}

void mysql_make_info_page(gtkwidget *widget){
    gtkwidget *label;
    
    label=gtk_label_new(hangul?"̿ť ׺  0.1.3\n\n: ú":"MySQL Navigator ver 0.1.3\n\nby j.s.b");
    gtk_widget_show(label);
    gtk_container_add(gtk_container(widget),label);
}

void j_banner_toggle(gtkwidget *widget,gpointer data){
    int y;
    y=gtk_toggle_button_get_active(gtk_toggle_button(widget));
    if(y==true){
	timer1=gtk_timeout_add(300,j_banner,null);
    }
    else{
	gtk_timeout_remove(timer1);
	gtk_statusbar_pop(gtk_statusbar(bar1),id1);
	timer1=null;
    }		
}

void j_time_toggle(gtkwidget *widget,gpointer data){
    int y;
    y=gtk_toggle_button_get_active(gtk_toggle_button(widget));
    if(y==true){
	timer3=gtk_timeout_add(300,j_timer,null);
    }
    else{
	gtk_timeout_remove(timer3);
	gtk_statusbar_pop(gtk_statusbar(bar3),id3);
	timer3=null;
    }		
}

void j_make_misc_page(gtkwidget *widget){
    gtkwidget *frame;
    gtkwidget *vbox;
    gtkwidget *button;
    
    vbox=gtk_vbox_new(false,10);
    gtk_container_set_border_width(gtk_container(vbox),10);    
    gtk_widget_show(vbox);
    gtk_container_add(gtk_container(widget),vbox);
    
    frame=gtk_frame_new(hangul?"":"banner");
    gtk_widget_show(frame);
    gtk_box_pack_start(gtk_box(vbox),frame,false,false,0);
    button=gtk_check_button_new_with_label(hangul?" ":"show banner");
    gtk_signal_connect(gtk_object(button),"toggled",gtk_signal_func(j_banner_toggle),null);
    gtk_widget_show(button);
    gtk_container_add(gtk_container(frame),button);
    
    frame=gtk_frame_new(hangul?"ð":"time");
    gtk_widget_show(frame);
    gtk_box_pack_start(gtk_box(vbox),frame,false,false,0);
    button=gtk_check_button_new_with_label(hangul?"ð ":"show time");
    gtk_toggle_button_set_active(gtk_toggle_button(button),true);
    gtk_signal_connect(gtk_object(button),"toggled",gtk_signal_func(j_time_toggle),null);
    gtk_widget_show(button);
    gtk_container_add(gtk_container(frame),button);
}

void j_make_setting_page(gtkwidget *widget){
    gtkwidget *note;
    gtkwidget *frame;
    gtkwidget *label;
    
    note=gtk_notebook_new();
    gtk_signal_connect(gtk_object(note),"switch-page",gtk_signal_func(tree_page),null);
    gtk_widget_show(note);
    gtk_container_add(gtk_container(widget),note);
    gtk_notebook_set_tab_pos(gtk_notebook(note),gtk_pos_right);

    frame=gtk_frame_new(null);
    gtk_widget_show(frame);
    label=gtk_label_new(hangul?"α":"log");
    gtk_widget_show(label);
    gtk_notebook_append_page(gtk_notebook(note),frame,label);
    j_make_log_page(frame);
    
    frame=gtk_frame_new(null);
    gtk_widget_show(frame);
    label=gtk_label_new(hangul?"¹":"bar");
    gtk_widget_show(label);
    gtk_notebook_append_page(gtk_notebook(note),frame,label);
    j_make_misc_page(frame);
}

void mysql_make_note(gtkwidget *hpaned){
    gtkwidget *hbox;
    gtkwidget *notebook;
    gtkwidget *label;
    gtkwidget *frame;
    
    notebook=gtk_notebook_new();
    gtk_signal_connect(gtk_object(notebook),"switch-page",gtk_signal_func(tree_page),null);
    gtk_notebook_set_tab_pos(gtk_notebook(notebook),gtk_pos_right);    
    gtk_widget_set_usize(notebook,750,500);

    gtk_paned_add2(gtk_paned(hpaned),notebook);
    gtk_widget_show(notebook);

    label=gtk_label_new(hangul?"":"info");
    frame=gtk_frame_new(null);
    gtk_notebook_append_page(gtk_notebook(notebook),frame,label);
    gtk_widget_show(label);
    gtk_widget_show(frame);
    mysql_make_info_page(frame);
    
    label=gtk_label_new(hangul?"":"run");
    frame=gtk_frame_new(null);
    gtk_notebook_append_page(gtk_notebook(notebook),frame,label);
    gtk_widget_show(label);
    gtk_widget_show(frame);
    j_make_run_page(frame);
    
    label=gtk_label_new(hangul?"":"edit");
    frame=gtk_frame_new(null);
    gtk_notebook_append_page(gtk_notebook(notebook),frame,label);
    gtk_widget_show(label);
    gtk_widget_show(frame);
    mysql_make_edit_page(frame);
    
    
    label=gtk_label_new(hangul?"":"user");
    frame=gtk_frame_new(null);
    gtk_notebook_append_page(gtk_notebook(notebook),frame,label);
    gtk_widget_show(label);
    gtk_widget_show(frame);
    mysql_make_user_page(frame);
    
    label=gtk_label_new(hangul?"Ÿ":"etc..");
    frame=gtk_frame_new(null);
    gtk_notebook_append_page(gtk_notebook(notebook),frame,label);
    gtk_widget_show(label);
    gtk_widget_show(frame);
    j_make_setting_page(frame);
}

void mysql_entry_reset(gtkwidget *widget,gpointer data){
    gtk_entry_set_text(gtk_entry(gtk_combo(data)->entry),"");
}    

void mysql_entry(gtkwidget *widget,gpointer data){
    gtk_button_clicked(gtk_button(data));
}    

void j_error_log(char *error){
    int f;
    long l;
    char y[300];
    time_t t;
    struct stat s;
    time(&t);
    modify_log_progress_bar();
    f=open(log_file,o_creat|o_excl|o_rdwr|o_append,0666);
    if(f==-1){
	f=open(log_file,o_rdwr|o_append);
    }
    fstat(f,&s);
    l=s.st_size;
    //g_print("%ld\n",l);
    if(l>log_max){
	//g_print("file trunc\n");	
	close(f);
	f=open(log_file,o_wronly|o_trunc);
    }	
    sprintf(y,"time: %suser: %s\nerror: %s\n\n",log_time?ctime(&t):"\n",log_user?user:"",log_error?error:"");
    write(f,y,strlen(y));
    close(f);
}    	

void init_db(){
    gtk_list_clear_items(gtk_list(gtk_combo(combo)->list),0,-1);
    g_list_free(item);
    item=null;
    res=mysql_list_dbs(&my_sql,null);
    while(row=mysql_fetch_row(res)){
        item=g_list_append(item,row[0]);
    }
    gtk_combo_set_popdown_strings(gtk_combo(combo),item);
    mysql_free_result(res);
}		

void mysql_fire(gtkwidget *widget,gpointer data){
    char my[50];
    char x[80];
        
    strcpy(my,gtk_entry_get_text((gtk_entry(gtk_combo(data)->entry))));
    if(list==null){
        strcpy(y[j],my);
        list=g_list_prepend(list,y[j++]);
        gtk_combo_set_popdown_strings(gtk_combo(data),list);
    }
    else{
        if(j==10){
	    gtk_list_clear_items(gtk_list(gtk_combo(data)->list),0,-1);
	    g_list_free(list);
	    list=null;
	    j=0;
	}	
	else{
	    gtk_list_clear_items(gtk_list(gtk_combo(data)->list),0,-1);
	}	
	strcpy(y[j],my);
	list=g_list_prepend(list,y[j++]);
	gtk_combo_set_popdown_strings(gtk_combo(data),list);
    }        
    mysql_select_db(&my_sql,(gtk_entry_get_text(gtk_entry(gtk_combo(combo)->entry))));
    if(mysql_query(&my_sql,my)){
	mysql_alert(mysql_error(&my_sql));
	if(error_log){
	    j_error_log(mysql_error(&my_sql));
	}    
	return;
    }
    res=mysql_store_result(&my_sql);
    
    if(strstr(my,"select")){
	mysql_view_table();
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"desc")){
	mysql_view_table();
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"describe")){
	mysql_view_table();
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"explain")){
	mysql_view_table();
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"show")){
	mysql_view_table();
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"insert")){
	mysql_alert(mysql_info(&my_sql));
	//mysql_alert("the query you enter has successully been executed");
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"load")){
	mysql_alert(mysql_info(&my_sql));
	//mysql_alert("the query you enter has successully been executed");
	mysql_free_result(res);
	return;
    }
    
    if(strstr(my,"delete")){
	mysql_alert("the query you enter has successfully been executed");
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"update")){
	mysql_alert(mysql_info(&my_sql));
	//mysql_alert("the query you enter has successfully been executed");
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"create database")){
	mysql_alert("the query you enter has successfully been executed");
	init_tree(tree);
	mysql_free_result(res);
	gtk_list_clear_items(gtk_list(gtk_combo(combo)->list),0,-1);
	g_list_free(item);
	item=null;
	res=mysql_list_dbs(&my_sql,null);
	while(row=mysql_fetch_row(res)){
	    item=g_list_append(item,row[0]);
    	}
    	gtk_combo_set_popdown_strings(gtk_combo(combo),item);
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"create table")){
	mysql_alert("the query you enter has successfully been executed");
	init_tree(tree);
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"drop database")){
	mysql_alert("the query you enter has successfully been exeuted");
	init_tree(tree);
	mysql_free_result(res);
	gtk_list_clear_items(gtk_list(gtk_combo(combo)->list),0,-1);
	g_list_free(item);
	item=null;
	res=mysql_list_dbs(&my_sql,null);
	while(row=mysql_fetch_row(res)){
	    item=g_list_append(item,row[0]);
    	}
    	gtk_combo_set_popdown_strings(gtk_combo(combo),item);
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"drop table")){
	mysql_alert("the query you enter has successfully been executed");
	init_tree(tree);
	mysql_free_result(res);
	return;
    }
    if(strstr(my,"alter table")){
	mysql_alert(mysql_info(&my_sql));
	//mysql_alert("the query you enter has successfully been executed");
	init_tree(tree);
	mysql_free_result(res);
	return;
    }
    mysql_alert("the query you enter has successfully been executed");        
    mysql_free_result(res);    
}    

void mysql_make_toolbar(gtkwidget *vbox){
    gtkwidget *button;
    gtkwidget *toolbar;
    gdkpixmap *data;
    gdkbitmap *mask;
    gtkwidget *pixmap;
    gtkstyle *style;
    gtkwidget *handlebox;
    gtkwidget *x;
    gtkwidget *fire;
    gtkwidget *label;
    
    handlebox=gtk_handle_box_new();
    gtk_widget_show(handlebox);
    gtk_box_pack_start(gtk_box(vbox),handlebox,false,false,0);
    toolbar=gtk_toolbar_new(gtk_orientation_horizontal,gtk_toolbar_icons);
    gtk_widget_show(toolbar);
    gtk_widget_set_usize(toolbar,0,35);
    gtk_container_add(gtk_container(handlebox),toolbar);
    
    gtk_toolbar_append_space(gtk_toolbar(toolbar));
    
    combo=gtk_combo_new();
    gtk_widget_show(combo);
    gtk_entry_set_editable(gtk_entry(gtk_combo(combo)->entry),false);
    gtk_widget_set_usize(combo,65,25);
    
    mysql_link();    
    res=mysql_list_dbs(&my_sql,null);
    while(row=mysql_fetch_row(res)){
	item=g_list_append(item,row[0]);
    }
    mysql_free_result(res);
    
    gtk_combo_set_popdown_strings(gtk_combo(combo),item);
    gtk_toolbar_append_element(gtk_toolbar(toolbar),gtk_toolbar_child_widget,combo,null,null,null,null,null,null);
    gtk_toolbar_append_space(gtk_toolbar(toolbar));

    fire=gtk_button_new_with_label("!");
    
    entry=gtk_combo_new();
    gtk_widget_show(entry);
    gtk_widget_set_usize(entry,400,25);
    gtk_signal_connect(gtk_object(gtk_combo(entry)->entry),"activate",gtk_signal_func(mysql_entry),(gpointer)fire);
    
    gtk_toolbar_append_element(gtk_toolbar(toolbar),gtk_toolbar_child_widget,entry,null,null,null,null,null,null);
    gtk_toolbar_append_space(gtk_toolbar(toolbar));

    /*
    style=gtk_widget_get_style(window);
    data=gdk_pixmap_create_from_xpm(window->window,&mask,&style->bg[gtk_state_normal],"wil.h");
    pixmap=gtk_pixmap_new(data,mask);
    gtk_widget_show(pixmap);
    gtk_toolbar_append_item(gtk_toolbar(toolbar),null,"run query",null,pixmap,gtk_signal_func(mysql_fire),(gpointer)entry);
    */

    gtk_signal_connect(gtk_object(fire),"clicked",gtk_signal_func(mysql_fire),(gpointer)entry);    
    gtk_toolbar_append_element(gtk_toolbar(toolbar),gtk_toolbar_child_widget,fire,null,null,null,null,null,null);
    gtk_toolbar_append_space(gtk_toolbar(toolbar));
}

void usage(){
    g_print("MySQL Navigator ver 0.1.3 by j.s.b\nusage: mn host user password\n");	
}

void parse_argument(int argc,char *argv[]){
    
    if(argc!=4){
	usage();
	exit(0);
    }
    host=argv[1];
    user=argv[2];
    password=argv[3];	
    /*
    int v;
    while((v=getopt(argc,argv,"h:u:p:"))!=-1){
	switch(v){
	    case 'h':
		host=optarg;
		break;
	    case 'u':
		user=optarg;
		break;
	    case 'p':
		password=optarg;
		break;
	}
    }
    if(host==null){
	usage();
	exit(0);				
    }
    if(user==null){
	usage();
	exit(0);				
    }
    if(password==null){
	usage();				
	exit(0);
    }
    */
}


int main(gint argc,gchar *argv[]){

    parse_argument(argc,argv);

    gnome_init("","",argc,argv);
    
    
    window=gtk_window_new(gtk_window_toplevel);
    gtk_window_set_title(gtk_window(window),hangul?"̿ť ׺  0.1.3":"MySQL Navigator ver 0.1.3");
    gtk_widget_set_usize(gtk_widget(window),500,600);
    gtk_container_set_border_width(gtk_container(window),5);
    gtk_signal_connect(gtk_object(window),"destroy",gtk_signal_func(gtk_quit),null);
    gtk_signal_connect(gtk_object(window),"key_press_event",gtk_signal_func(my_key_press),null);
    
    vbox=gtk_vbox_new(false,3);
    gtk_container_add(gtk_container(window),vbox);
    gtk_widget_show(vbox);
    mysql_make_toolbar(vbox);
    
    hpaned=gtk_hpaned_new();
    gtk_box_pack_start(gtk_box(vbox),hpaned,true,true,0);
    gtk_widget_show(hpaned);

    hbox=gtk_hbox_new(false,1);
    gtk_widget_show(hbox);
    gtk_box_pack_start(gtk_box(vbox),hbox,false,false,0);
    j_make_sbar(hbox);
    
    mysql_make_note(hpaned);
    my_make_tree_note(hpaned);
    
    gtk_widget_show(window);
    
    gtk_main();
    return true;
}    
    
    
    
